<?php
namespace W3ctrl\Fsfpay\Helper;

use Magento\Framework\Encryption\EncryptorInterface;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Store\Model\ScopeInterface;

/**
 * Class Data Helper
 */
class Data
{


    const CONFIG_FSFPAY_API_USERNAME = 'payment/w3ctrlfsfpay/api_username';
    const CONFIG_FSFPAY_API_KEY      = 'payment/w3ctrlfsfpay/api_key';
    const CONFIG_FSFPAY_SECRET_KEY   = 'payment/w3ctrlfsfpay/secret_key';
    const CONFIG_FSFPAY_TEST_MODE    = 'payment/w3ctrlfsfpay/test_mode';
    const CONFIG_FSFPAY_DEBUG_MODE    = 'payment/w3ctrlfsfpay/debug_mode';
    /** @var EncryptorInterface */
    private $encryptor;
    private $scopeConfig;
    public function __construct(ScopeConfigInterface $scopeConfig, EncryptorInterface $encryptor)
    {
        $this->encryptor = $encryptor;
        $this->scopeConfig = $scopeConfig;
    }

    public function getApiUsername()
    {
        $storeScope = \Magento\Store\Model\ScopeInterface :: SCOPE_STORE;
     return $this->scopeConfig->getValue(self :: CONFIG_FSFPAY_API_USERNAME, $storeScope);
    }

    public function getApiKey()
    {
        $storeScope = \Magento\Store\Model\ScopeInterface :: SCOPE_STORE;
        return $this->scopeConfig->getValue(self :: CONFIG_FSFPAY_API_KEY, $storeScope);
    }

    public function getSecretKey()
    {
        $storeScope = \Magento\Store\Model\ScopeInterface :: SCOPE_STORE;
        return $this->scopeConfig->getValue(self :: CONFIG_FSFPAY_SECRET_KEY, $storeScope);
    }

    public function isTestMode()
    {
        $storeScope = \Magento\Store\Model\ScopeInterface :: SCOPE_STORE;
        return $this->scopeConfig->getValue(self :: CONFIG_FSFPAY_TEST_MODE, $storeScope);
    }

    public function isDebugEnable()
    {
        $storeScope = \Magento\Store\Model\ScopeInterface :: SCOPE_STORE;
        return $this->scopeConfig->getValue(self :: CONFIG_FSFPAY_DEBUG_MODE, $storeScope);
    }


    public function simplePost($data)
    {

    $curl = curl_init();
$apiKey = '13c3b12b0c1521f232782a907d646f75';
$apiUsername = 'becky1992j';
$secretKey = '0cb35e2a54fc6b91c3170f6bbc41f25c';
$data['requestHash'] = hash('sha256', $this->getApiKey() . $this->getApiUsername() . $this->getSecretKey());
        curl_setopt_array($curl, [
            CURLOPT_URL => 'https://panel.fsfpay.com/api/payment',
            CURLOPT_HTTPHEADER => [
                'Content-Type: application/x-www-form-urlencoded'
            ],
            CURLOPT_POST => true,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POSTFIELDS => http_build_query($data)
        ]);
        $response = curl_exec($curl);
        curl_close($curl);

        return json_decode($response, true);
    }


    public function debugfsfpay($data)
    {

        if ($this->isDebugEnable()) {
            $writer = new \Zend\Log\Writer\Stream(BP . '/var/log/fsfpay.log');
            $logger = new \Zend\Log\Logger();
            $logger->addWriter($writer);
            $logger->debug($data);
        }
    }
}
